/**
 * ppilot 2.0 for Android
 * 
 * Philippe Truillet
 * Last modified: 23/08/2011
 */

package fr.irit.elipse.util.tts;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;

import java.util.Locale;

import android.speech.tts.*;

import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.Button;
import android.widget.TextView;

import fr.dgac.ivy.*;

public class ppilot extends Activity implements TextToSpeech.OnInitListener, OnClickListener {
	private TextToSpeech myTts;
	private Ivy bus;
	private Button mButton;
	private String mivyaddress = null;
		
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);       
		setContentView(R.layout.main);
		
        // Initialize text-to-speech. This is an asynchronous operation.
        // The OnInitListener (second argument) is called after initialization completes.
        myTts = new TextToSpeech(this, this);
        mButton = (Button)findViewById(R.id.button);
         
        try
		{
			bus=new Ivy("ppilot","ppilot can talk on a Android Phone",null);
			bus.bindMsg("^ppilot Command=(.*)", new IvyMessageListener()
			{
				public void receive(IvyClient client,String[] args)
				{                 
					try 
					{
						/*
						if(args[0].compareTo("Start")==0)
						{
							// nothing to do now
						}
						*/
						
						if(args[0].compareTo("Stop")==0)
						{
							bus.stop();
							if (myTts != null) {
								myTts.stop();
							    myTts.shutdown();
							}
							finish();
						}
					}
					catch (Exception e) {}  
				} 				
			  });
			 bus.bindMsg("^ppilot Say=(.*)", new IvyMessageListener()
			 {
				public void receive(IvyClient client,String[] args)
				{                 
					try 
					{
						myTts.speak(args[0], TextToSpeech.QUEUE_FLUSH, null);
					}
					catch (Exception e) {}  
				} 				
			  });									
		}
		catch(IvyException e)
		{			
		}			
			
        /*
         * On enregistre l'activit auprs du bouton pour recevoir
         * les vnements "clic" provoqus par l'utilisateur.
         */
        mButton.setOnClickListener(this);     	
		mivyaddress = Ivy.getDomain(null);		
	}
    
	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		try
		{			
			Log.i(ACTIVITY_SERVICE, "Lancement bus ivy");
			bus.start(mivyaddress);	
				myTts.speak("le bus ivy vient d'tre lanc", TextToSpeech.QUEUE_FLUSH, null);  
		}
		catch(IvyException e)
		{
			Log.i(ACTIVITY_SERVICE, "Erreur lancement bus ivy");
		}			
		mButton.setEnabled(false);		
	}
   
	@Override
	 public void onDestroy() {
		Log.i(ACTIVITY_SERVICE, "onDestroy()");
		super.onDestroy(); 		
		finish();
	    // android.os.Process.killProcess(android.os.Process.myPid());
	 }

	// Implements TextToSpeech.OnInitListener.
    public void onInit(int status) {
        // status can be either TextToSpeech.SUCCESS or TextToSpeech.ERROR.
        if (status == TextToSpeech.SUCCESS) {
            // Set preferred language to US english.
            // Note that a language may not be available, and the result will indicate this.
            // int result = myTts.setLanguage(Locale.US);
            // Try this someday for some interesting results.
            int result = myTts.setLanguage(Locale.FRANCE);
            if (result == TextToSpeech.LANG_MISSING_DATA ||
                result == TextToSpeech.LANG_NOT_SUPPORTED) {              
            } else {
                // Check the documentation for other possible result codes.
                // For example, the language may be available for the locale,
                // but not for the specified country and variant.
                // The TTS engine has been successfully initialized.  
            	myTts.speak("Je suis prt  parler !", TextToSpeech.QUEUE_FLUSH, null);  
            	((TextView)findViewById(R.id.ivyaddress)).setText(mivyaddress);
            }
        } 
    }
    
    /*
	private void CreateMenu(Menu menu){
		menu.setQwertyMode(true);		
	}
    */ 

	//---only created once---
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Cration d'un MenuInflater qui va permettre d'instancier un Menu XML en un objet Menu
        MenuInflater inflater = getMenuInflater();
        // Instantiation du menu XML spcifi en un objet Menu
        inflater.inflate(R.layout.menu, menu);
        return true;
    }
 
    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
     switch (item.getItemId()) {
       
        case R.id.option:
        	// ouvrir bote  options optionbox       	
        	Intent intent = new Intent(this, optionbox.class);
            this.startActivityForResult(intent, 1);
        	return(true);
        	
        case R.id.about:
        	// ouvrir bote about       	
        	Intent intent2 = new Intent(this, about.class);
            this.startActivity(intent2);
        	return(true);
        	
        case R.id.quitter:
			finish();	
            return true;
        }
        return false;     	 
    }
    
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data){
    		
    	if (requestCode == 1 && data != null)
    		{
    			mivyaddress = data.getStringExtra("adresse");
    			Log.i(ACTIVITY_SERVICE, "retour intent : " + mivyaddress);
    			((TextView)findViewById(R.id.ivyaddress)).setText(mivyaddress);
 
    			try
    			{
        			Log.i(ACTIVITY_SERVICE, "Arret bus ivy");
        			bus.stop();
    				Log.i(ACTIVITY_SERVICE, "Lancement bus ivy");
    				bus.start(mivyaddress);
    				myTts.speak("changement d'adresse d'coute pour " + mivyaddress, TextToSpeech.QUEUE_FLUSH, null);  
    			}
    			catch(IvyException ie) {
    				Log.i(ACTIVITY_SERVICE, "Erreur arret/lancement ivy");
    				finish();
    			}
    			catch(Exception e) {
    				Log.i(ACTIVITY_SERVICE, "Erreur indeterminee a l'arret ou au lancement ivy");
    				finish();
    			}
    		}
    		else
    		{
    			((TextView)findViewById(R.id.ivyaddress)).setText("<Erreur>");
    		}
    }
    
}